require("research")
require("prototypes/entities")
require("prototypes/containers")

--shortcut
local shortcut = {
  type="shortcut",
  name="warptorio-teleport",
  action="lua",
  icon="__warptorio-space-age__/graphics/home.png",
  small_icon="__warptorio-space-age__/graphics/home.png"
}
data:extend{shortcut}

-- promethium
local promethium = data.raw["recipe"]["promethium-science-pack"]
promethium.surface_conditions = nil
local chunk = table.deepcopy(data.raw["recipe"]["fluoroketone"])
chunk.ingredients = {
  {
    amount = 1000,
    name = "lava",
    type = "fluid"
  },
  {
    amount = 250,
    name = "ammonia",
    type = "fluid"
  },
  {
    amount = 10,
    name = "uranium-235",
    type = "item"
  },
  {
    amount = 200,
    name = "holmium-solution",
    type = "fluid"
  }
}
chunk.results = {
  {
    amount = 5,
    name = "promethium-asteroid-chunk",
    type = "item"
  }
}
chunk.name = "warp-promethium"
data:extend{chunk}


local tile_platform = table.deepcopy(data.raw["tile"][settings.startup["warptorio_factory-tile"].value])
tile_platform.minable_properties = {
  minable = false
}
tile_platform.name = "warp_tile_platform"

local tile_world = table.deepcopy(data.raw["tile"][settings.startup["warptorio_ground-tile"].value])
tile_world.minable_properties = {
  minable = false
}
tile_world.name = "warp_tile_world"

data:extend{tile_platform,tile_world}


local belt_speeds = {15,30,45,60}
local belt_color = {
  {1,1,0.5},
  {1,0.5,0.5},
  {0.5,0.5,1},
  {0.5,1,0.5}
}
for i,v in ipairs(belt_speeds) do
  local belt = table.deepcopy(data.raw["linked-belt"]["linked-belt"])
  belt.speed = v/480
  belt.minable_properties = {
    minable = false
  }
  belt.name = "warp-platform-belt-"..v
  --belt.pictures.layers[1].tint = belt_color[i]
  data:extend{belt}
end

local acc = table.deepcopy(data.raw["accumulator"]["accumulator"])
acc.name = "warp-power"
acc.minable_properties = {
  minable = false
}
acc.energy_source = -- energy source of accumulator
{
  type = "electric",
  buffer_capacity = "1GJ",
  usage_priority = "tertiary",
  input_flow_limit = "1TW",
  output_flow_limit = "1TW"
}
data:extend{acc}

local acc = table.deepcopy(data.raw["accumulator"]["accumulator"])
acc.name = "warp-power-2"
acc.minable_properties = {
  minable = false
}
acc.energy_source = -- energy source of accumulator
{
  type = "electric",
  buffer_capacity = "5GJ",
  usage_priority = "tertiary",
  input_flow_limit = "1TW",
  output_flow_limit = "1TW"
}
data:extend{acc}

local acc = table.deepcopy(data.raw["accumulator"]["accumulator"])
acc.name = "warp-power-3"
acc.minable_properties = {
  minable = false
}
acc.energy_source = -- energy source of accumulator
{
  type = "electric",
  buffer_capacity = "25GJ",
  usage_priority = "tertiary",
  input_flow_limit = "1TW",
  output_flow_limit = "1TW"
}
data:extend{acc}

-- change space science so it can be made anywhere

data.raw["recipe"]["space-science-pack"].surface_conditions[1].max = 10
data.raw["recipe"]["space-science-pack"].energy_required = 60



--[[local test = table.deepcopy(data.raw["planet"]["nauvis"])
test.icon = "__warptorio-2.0__/graphics/destinations/moon.png"
test.icon_size = 128
test.name = "lost_factory"

--planet settings
test.distance = 4000000

data:extend{test}]]

--[[local warp_map_gen = require("surfaces")

local test = table.deepcopy(data.raw["planet"]["vulcanus"])
test.icon = "__warptorio-2.0__/graphics/destinations/moon.png"
test.icon_size = 128
test.name = "test"
test.map_gen_settings = warp_map_gen.test()

data:extend{test}

-- No idea how else get map_gen_settings durring run time

local base = data.raw["planet"]
local map_gen_settings = {}

for i,v in pairs(base) do
  map_gen_settings[i] = v.map_gen_settings
end


local bigpack = require("__big-data-string2__.pack")

local function set_my_data(name, data)
    return bigpack("warptorio-map-gen", serpent.dump(data))
end
-- use it like this
data:extend{set_my_data(name, map_gen_settings)}]]
